<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Select2 -->
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  
  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Quản lý bảng điểm</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Task 48.10</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Hieu Nguyen</a>
        </div>
      </div>


      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="#" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản lý bảng điểm</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index2.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v2</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index3.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Dashboard v3</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Quản lý bảng điểm</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Quản lý bảng điểm</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="jumbotron container py-2">
        <h5>Thông tin sinh viên</h5>
        <div class="row">
          <div class="col-sm-5">
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Họ tên</label>
              </div>
              <div class="col-sm-8">
                <select id="select-student-filter" class="form-control select-student select2">
                  <option value="">(tất cả)</option>
                </select>
              </div>
            </div>
          </div>
          <div class="col-sm-5">
            <div class="row form-group">
              <div class="col-sm-4">
                <label>Subject</label>
              </div>
              <div class="col-sm-8">
                <select id="select-subject-filter" class="form-control select-subject select2">
                  <option value="">(tất cả)</option>
                </select>
              </div>
            </div>
          </div>
          <div class="col-sm-2">
            <button id="btn-filter-grade" class="btn btn-info">Lọc</button>
          </div>
        </div>
      </div>
      <button id="btn-add-grade" class="form-group btn btn-success"><i class="fa fa-plus"></i> Thêm Điểm</button>
      <div class="container">
        <h4 class="text-center">Danh sách điểm</h4>
        <table class="table table-bordered table-striped table-hover" id="table-grades">
          <thead>
            <tr>
              <th>STT</th>
              <th>Student</th>
              <th>Môn học</th>
              <th>Điểm</th>
              <th>Ngày thi</th>
              <th>Action</th>
            </tr>
          </thead>
        </table>
      </div>
      <!--Modal add grade-->
      <div>
        <div id="modal-add-grade" class="modal fade">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">Thêm điểm</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <form>
                  <div class="row form-group">
                    <div class="col-sm-3 pr-0">
                      <label>Họ tên</label>
                    </div>
                    <div class="col-sm-9 pl-0">
                      <select id="select-add-grade-student" class="form-control select-student select2" style="width:100%"></select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-3 pr-0">
                      <label>Môn học</label>
                    </div>
                    <div class="col-sm-9 pl-0">
                      <select id="select-add-grade-subject" class="form-control select-subject select2" style="width:100%"></select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-3 pr-0">
                      <label>Điểm</label>
                    </div>
                    <div class="col-sm-9 pl-0">
                      <input type="number" id="inp-add-grade-grade" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-3 pr-0">
                      <label>Ngày thi</label>
                    </div>
                    <div class="col-sm-9 pl-0">
                      <input type="text" id="inp-add-grade-exam-date" class="form-control">
                    </div>
                  </div>
                </form>
              </div>
              <div class="modal-footer">
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                <button class="btn btn-primary" id="btn-confirm-add-grade">Thêm điểm</button>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!--Model Edit grade-->
      <div>
        <div id="modal-edit-grade" class="modal fade">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title">Sửa điểm</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <form>
                  <div class="row form-group">
                    <div class="col-sm-3 pr-0">
                      <label>Họ tên</label>
                    </div>
                    <div class="col-sm-9 pl-0">
                      <select id="select-edit-grade-student" class="form-control select-student select2" style="width:100%"></select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-3 pr-0">
                      <label>Môn học</label>
                    </div>
                    <div class="col-sm-9 pl-0">
                      <select id="select-edit-grade-subject" class="form-control select-subject select2" style="width:100%"></select>
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-3 pr-0">
                      <label>Điểm</label>
                    </div>
                    <div class="col-sm-9 pl-0">
                      <input type="number" id="inp-edit-grade-grade" class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-3 pr-0">
                      <label>Ngày thi</label>
                    </div>
                    <div class="col-sm-9 pl-0">
                      <input type="text" id="inp-edit-grade-exam-date" class="form-control">
                    </div>
                  </div>
                </form>
              </div>
              <div class="modal-footer">
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                <button class="btn btn-primary" id="btn-confirm-edit-grade">Sửa điểm</button>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- Modal confirm delete grade  -->
      <div>
        <div class="modal fade" tabindex="-1" id="modal-delete-grade">
          <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Xác nhận xóa Điểm</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <label>Bạn có chắc chắn muốn xóa Điểm này không?</label>
              </div>
              <div class="modal-footer">
                <button class="btn btn-danger" id="btn-confirm-delete-grade">Xóa Điểm</button>
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
              </div>
            </div>
          </div>
        </div>
      </div>
      
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 3.2.0
    </div>
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> Task 48.10 01-07-2022.
  </footer>


</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>

<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>

<!-- Select2 -->
<script src="plugins/select2/js/select2.full.min.js"></script>

<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>
</body>
<script>
  "use strict";
  /*** VÙNG 1: BIẾN TOÀN CỤC ***/
  var gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
  var gStudents = [];
  var gSubjects = [];
  var gGrades = [];
  var gGradeId = 0;
  var gColNameList = ["id", "studentId", "subjectId", "grade", "examDate", "action"];
  const gCOL_ID = 0;
  const gCOL_STUDENT_ID = 1;
  const gCOL_SUBJECT_ID = 2;
  const gCOL_GRADE = 3;
  const gCOL_EXAM_DATE = 4;
  const gCOL_ACTION = 5;
  var gStt = 0;
  var gGradeTable = $("#table-grades").DataTable({
      columns: [
        {data: gColNameList[gCOL_ID]},
        {data: gColNameList[gCOL_STUDENT_ID]},
        {data: gColNameList[gCOL_SUBJECT_ID]},
        {data: gColNameList[gCOL_GRADE]},
        {data: gColNameList[gCOL_EXAM_DATE]},
      ],
      columnDefs: [
        {
          targets: gCOL_ID,
          render: renderStt,
        },
        {
          targets: gCOL_STUDENT_ID,
          render: function(data) {
            return getStudentNameByStudentId(data)
          },
        },
        {
          targets: gCOL_SUBJECT_ID,
          render: function(data) {
            return getSubjectNameBySubjectId(data)
          },
        },
        {
          targets: gCOL_ACTION,
          defaultContent: `
            <div class="d-inline-flex">
              <button class="btn btn-link btn-edit" title="Sửa"><i class="far fa-edit text-primary"></i></button>
              <button class="btn btn-link btn-delete" title="Xóa"><i class="fas fa-trash-alt text-danger"></i></button>
            </div>
          `
        },
      ]
    })

  /*** VÙNG 2: GÁN SỰ KIỆN CHO CÁC PHẦN TỬ ***/
  $(document).ready(function(){
    callAjaxApiGetStudentList();
    callAjaxApiGetSubjectList();
    callAjaxApiGetGradeList();
    loadDataToTable(gGrades);
    loadDataToSelectStudent(gStudents);
    loadDataToSelectSubject(gSubjects);
    $('.select2').select2()
  })
  $("#btn-filter-grade").click(onBtnFilterGradeClick)
  $("#btn-add-grade").on("click", onBtnAddGradeClick)
  $("#table-grades").on("click", ".btn-edit", function(){
      onBtnEditClick(this)
  });
  $("#table-grades").on("click", ".btn-delete", function(){
      onBtnDeleteClick(this)
  });
  $("#btn-confirm-add-grade").on("click", onBtnConfirmAddGradeClick)
  $("#btn-confirm-edit-grade").on("click", onBtnConfirmEditGradeClick)
  $("#btn-confirm-delete-grade").on("click", onBtnConfirmDeleteGradeClick)

  /*** VÙNG 3: HÀM XỬ LÝ SỰ KIỆN ***/
  function onBtnFilterGradeClick() {
    var vDataToFilter = {
      studentId: "",
      subjectId: ""
    }
    //B1: đọc dữ liệu
    getDataToFilter(vDataToFilter);
    console.log("Dữ liệu cần lọc là");
    console.log(vDataToFilter);
    //B2: kiểm tra dữ liệu
    //B3: lọc dữ liệu
    var vFilteredGradeList = filterGradeByStudentIdAndSubjectId(vDataToFilter);
    console.log("Các điểm đã lọc được là:");
    console.log(vFilteredGradeList)
    //B4: hiển thị dữ liệu
    loadDataToTable(vFilteredGradeList)
  }
  function onBtnAddGradeClick() {
    $("#modal-add-grade").modal("show");
  }
  function onBtnEditClick(paramButtonElement) {
    "use strict";
    $("#modal-edit-grade").modal("show");
    var vCurrentRow = $(paramButtonElement).closest("tr");
    var vRowData = gGradeTable.row(vCurrentRow).data();
    gGradeId = Number(vRowData.id); // lưu Id của điểm vào 1 biến toàn cục
    console.log("Nút Sửa được ấn. Id là: " + gGradeId);
    loadDataToModalEditGrade(vRowData);
  }
  function onBtnDeleteClick(paramButtonElement) {
    "use strict";
    $("#modal-delete-grade").modal("show");
    var vCurrentRow = $(paramButtonElement).closest("tr");
    var vRowData = gGradeTable.row(vCurrentRow).data();
    gGradeId = vRowData.id;
    console.log("Nút Xóa được ấn. Id là: " + gGradeId);
  }
  function onBtnConfirmAddGradeClick() {
    var vGradeObjToAdd = {
      studentId: 0,
      subjectId: 0,
      grade: 0,
      examDate: ""
    };
    //bước 1: lấy dữ liệu từ các input
    getDataFromModalAddGrade(vGradeObjToAdd);
    console.log("Ghi tạm đối tượng dữ liệu ra console");
    console.log(vGradeObjToAdd);
    //bước 2: kiểm tra dữ liệu lấy từ các input
    var vCheckResult = validateGradeData(vGradeObjToAdd);
    console.log("Kết quả kiểm tra dữ liệu là: " + vCheckResult);
    if (vCheckResult == true) {
    //bước 3: tạo điểm mới
      callAjaxApiAddGrade(vGradeObjToAdd);
      callAjaxApiGetGradeList();
      loadDataToTable(gGrades);
      resetModalAddGrade();
      $("#modal-add-grade").modal("hide")
    }
  }
  function onBtnConfirmEditGradeClick() {
    var vGradeObjToEdit = {
      studentId: 0,
      subjectId: 0,
      grade: 0,
      examDate: ""
    };
    //bước 1: lấy dữ liệu từ các input
    getDataFromModalEditGrade(vGradeObjToEdit);
    console.log("Ghi tạm đối tượng dữ liệu ra console");
    console.log(vGradeObjToEdit);
    //bước 2: kiểm tra dữ liệu lấy từ các input
    var vCheckResult = validateGradeData(vGradeObjToEdit);
    console.log("Kết quả kiểm tra dữ liệu là: " + vCheckResult);
    if (vCheckResult == true) {
    //bước 3:  update Grade data
    callAjaxApiEditGrade(gGradeId, vGradeObjToEdit);
    callAjaxApiGetGradeList();
    loadDataToTable(gGrades);
    $("#modal-edit-grade").modal("hide")
    }
  }
  function onBtnConfirmDeleteGradeClick() {
    callAjaxApiDeleteGrade(gGradeId);
    callAjaxApiGetGradeList();
    loadDataToTable(gGrades);
    $("#modal-delete-grade").modal("hide")
  }

  /*** VÙNG 4: HÀM DÙNG CHUNG ***/
  function callAjaxApiGetStudentList() {
    $.ajax({
      async: false,
      url: gBASE_URL + "/students",
      type: "GET",
      data: "json",
      success: function(res) {
        gStudents = res;
        console.log(res)
      },
      error: function(err) {
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    })
  }
  function callAjaxApiGetSubjectList() {
    $.ajax({
      async: false,
      url: gBASE_URL + "/subjects",
      type: "GET",
      data: "json",
      success: function(res) {
        gSubjects = res;
        console.log(res)
      },
      error: function(err) {
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    })
  }
  function callAjaxApiGetGradeList() {
    $.ajax({
      async: false,
      url: gBASE_URL + "/grades",
      type: "GET",
      data: "json",
      success: function(res) {
        gGrades = res;
        console.log(res)
      },
      error: function(err) {
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    })
  }
  function getDataFromModalAddGrade(paramGradeObject) {
    paramGradeObject.studentId = Number($("#select-add-grade-student").val());
    paramGradeObject.subjectId = Number($("#select-add-grade-subject").val());
    if ($("#inp-add-grade-grade").val() == "") {
      paramGradeObject.grade = ""
    }
    else {
      paramGradeObject.grade = Number($("#inp-add-grade-grade").val());
    };
    paramGradeObject.examDate = $("#inp-add-grade-exam-date").val();
  }
  function getDataFromModalEditGrade(paramGradeObject) {
    paramGradeObject.studentId = Number($("#select-edit-grade-student").val());
    paramGradeObject.subjectId = Number($("#select-edit-grade-subject").val());
    if ($("#inp-edit-grade-grade").val() == "") {
      paramGradeObject.grade = ""
    }
    else {
      paramGradeObject.grade = Number($("#inp-edit-grade-grade").val());
    };
    paramGradeObject.examDate = $("#inp-edit-grade-exam-date").val();
  }
  function loadDataToModalEditGrade(paramRowData) {
    $("#select-edit-grade-student").val(Number(paramRowData.studentId));
    $("#select-edit-grade-subject").val(Number(paramRowData.subjectId));
    $("#inp-edit-grade-grade").val(Number(paramRowData.grade));
    $("#inp-edit-grade-exam-date").val(paramRowData.examDate);
    $('.select2').select2();
  }
  function validateGradeData(paramGradeObject) {
    var vCheckResult = false;
    if (paramGradeObject.studentId == 0) {
      console.log("Chưa nhập Họ tên");
      alert("Chưa nhập Họ tên")
    }
    else if (paramGradeObject.subjectId == 0) {
      console.log("Chưa nhập Môn học");
      alert("Chưa nhập Môn học")
    }
    else if (paramGradeObject.grade === "") {
      console.log("Chưa nhập Điểm");
      alert("Chưa nhập Điểm")
    }
    else if (paramGradeObject.grade < 0 || paramGradeObject.grade > 10) {
      console.log("Điểm không thể < 0 hoặc > 10");
      alert("Điểm không thể < 0 hoặc > 10")
    }
    else if (paramGradeObject.examDate == "") {
      console.log("Chưa nhập Ngày thi");
      alert("Chưa nhập Ngày thi")
    }
    else {
      vCheckResult = true
    }
    return vCheckResult
  }
  function callAjaxApiAddGrade(paramGradeObjToAdd) {
    $.ajax({
      async: false,
      url: gBASE_URL + "/grades",
      type: "POST",
      contentType: "application/json",
      data: JSON.stringify(paramGradeObjToAdd),
      dataType: "json",
      success: function(res) {
        alert("Tạo Điểm mới thành công! Id điểm mới là " + res.id);
        console.log(res)
      },
      error: function(err) {
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    })
  }
  function callAjaxApiEditGrade(paramGradeId, paramGradeObjToEdit) {
    $.ajax({
      async: false,
      url: gBASE_URL + "/grades/" + paramGradeId,
      type: "PUT",
      contentType: "application/json",
      data: JSON.stringify(paramGradeObjToEdit),
      dataType: "json",
      success: function(res) {
        alert("Sửa Điểm thành công cho điểm có Id là " + res.id);
        console.log(res)
      },
      error: function(err) {
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    })
  }
  function callAjaxApiDeleteGrade(paramGradeId) {
    $.ajax({
      async: false,
      url: gBASE_URL + "/grades/" + paramGradeId,
      type: "DELETE",
      dataType: "json",
      success: function(res) {
        alert("Xóa thành công điểm có Id là " + paramGradeId + "!");
        console.log(res)
      },
      error: function(err) {
        console.log(err);
        alert("Có lỗi! Xem console")
      }
    })
  }
  function resetModalAddGrade() {
    $("#inp-add-grade-grade").val("");
    $("#inp-add-grade-exam-date").val("");
  }
  function renderStt() {
    gStt ++;
    return gStt
  }
  function getStudentNameByStudentId(paramStudentId) { // hàm trả về student full name dựa vào studentId
    "use strict";
    var vStudentName = "";
    var vIndex = 0;
    var vIsStudentFound = false;
    while(!vIsStudentFound && vIndex < gStudents.length) {
      if(gStudents[vIndex].id == paramStudentId) {
        vIsStudentFound = true;
        vStudentName = gStudents[vIndex].firstname + " " + gStudents[vIndex].lastname;
      }
      else {
        vIndex ++;
      }
    }
    return vStudentName;
  }
  function getSubjectNameBySubjectId(paramSubjectId) { // hàm trả về subject name dựa vào subjectId
    "use strict";
    var vSubjectName = "";
    var vIndex = 0;
    var vIsSubjectFound = false;
    while(!vIsSubjectFound && vIndex < gSubjects.length) {
      if(gSubjects[vIndex].id == paramSubjectId) {
        vIsSubjectFound = true;
        vSubjectName = gSubjects[vIndex].subjectName;
      }
      else {
        vIndex ++;
      }
    }
    return vSubjectName;
  }
  function loadDataToTable(paramGradeList) {
    gStt = 0;
    $("#table-grades").DataTable()
      .clear()
      .rows.add(paramGradeList)
      .draw()
  }
  function loadDataToSelectStudent(paramStudentList) {
    for (let bStudent of paramStudentList) {
      $(".select-student")
        .append($("<option>")
          .val(Number(bStudent.id))
          .text(bStudent.firstname + " " + bStudent.lastname)
        )
    }
  }
  function loadDataToSelectSubject(paramSubjectList) {
    for (let bSubject of paramSubjectList) {
      $(".select-subject")
        .append($("<option>")
          .val(Number(bSubject.id))
          .text(bSubject.subjectName)
        )
    }
  }
  function getDataToFilter(paramFilterObj) {
    paramFilterObj.studentId = $("#select-student-filter").val();
    paramFilterObj.subjectId = $("#select-subject-filter").val();
  }
  function filterGradeByStudentIdAndSubjectId(paramFilterObj) {
    var vFilteredGradeList = gGrades.filter(function(item) {
      return (
        (paramFilterObj.studentId == "" || item.studentId == paramFilterObj.studentId) &&
        (paramFilterObj.subjectId == "" || item.subjectId == paramFilterObj.subjectId)
      )
    })
    return vFilteredGradeList
  }
</script>
</html>
